Index: issm/trunk/src/m/classes/flowequation.m
===================================================================
--- issm/trunk/src/m/classes/flowequation.m	(revision 25994)
+++ issm/trunk/src/m/classes/flowequation.m	(revision 26744)
@@ -62,8 +62,7 @@
 			end
 
-			%Oct 8 2020
-			%Warning if MLHO
+			%Nov 6 2021
 			if any(self.vertex_equation==4)
-				warning(['Monolayer Higher-Order (MLHO) detected in md.flowequation, this is probably a mistake, you need to run setflowequation again']);
+				disp(['Monolayer Higher-Order (MLHO) detected in md.flowequation, this is still under development. Please double check your settings.']);
 			end
 
@@ -122,6 +121,6 @@
 			md = checkfield(md,'fieldname','flowequation.borderFS','size',[md.mesh.numberofvertices 1],'values',[0 1]);
 			if strcmp(domaintype(md.mesh),'2Dhorizontal')
-				md = checkfield(md,'fieldname','flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[1:2]);
-				md = checkfield(md,'fieldname','flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[1:2]);
+				md = checkfield(md,'fieldname','flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[1,2,4]);
+				md = checkfield(md,'fieldname','flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[1,2,4]);
 			elseif strcmp(domaintype(md.mesh),'3Dsurface')
 				md = checkfield(md,'fieldname','flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[1:2]);
Index: issm/trunk/src/m/classes/flowequation.py
===================================================================
--- issm/trunk/src/m/classes/flowequation.py	(revision 25994)
+++ issm/trunk/src/m/classes/flowequation.py	(revision 26744)
@@ -27,9 +27,9 @@
         self.fe_HO = ''
         self.fe_FS = ''
-        self.augmented_lagrangian_r = 1.
-        self.augmented_lagrangian_rhop = 1.
-        self.augmented_lagrangian_rlambda = 1.
-        self.augmented_lagrangian_rholambda = 1.
-        self.XTH_theta = 0.
+        self.augmented_lagrangian_r = 1
+        self.augmented_lagrangian_rhop = 1
+        self.augmented_lagrangian_rlambda = 1
+        self.augmented_lagrangian_rholambda = 1
+        self.XTH_theta = 0
         self.vertex_equation = np.nan
         self.element_equation = np.nan
@@ -107,6 +107,9 @@
         md = checkfield(md, 'fieldname', 'flowequation.XTH_theta', 'numel', [1], '>=', 0., '<', .5)
         if m.strcmp(md.mesh.domaintype(), '2Dhorizontal'):
-            md = checkfield(md, 'fieldname', 'flowequation.vertex_equation', 'size', [md.mesh.numberofvertices], 'values', [1, 2])
-            md = checkfield(md, 'fieldname', 'flowequation.element_equation', 'size', [md.mesh.numberofelements], 'values', [1, 2])
+            md = checkfield(md, 'fieldname', 'flowequation.vertex_equation', 'size', [md.mesh.numberofvertices], 'values', [1, 2, 4])
+            md = checkfield(md, 'fieldname', 'flowequation.element_equation', 'size', [md.mesh.numberofelements], 'values', [1, 2, 4])
+        elif m.strcmp(md.mesh.domaintype(), '3Dsurface'):
+            md = checkfield(md, 'fieldname', 'flowequation.vertex_equation', 'size', [md.mesh.numberofvertices], 'values', np.arange(1, 2 + 1))
+            md = checkfield(md, 'fieldname', 'flowequation.element_equation', 'size', [md.mesh.numberofelements], 'values', np.arange(1, 2 + 1))
         elif m.strcmp(md.mesh.domaintype(), '2Dvertical'):
             md = checkfield(md, 'fieldname', 'flowequation.vertex_equation', 'size', [md.mesh.numberofvertices], 'values', [2, 5, 6])
@@ -117,4 +120,5 @@
         else:
             raise RuntimeError('Case not supported yet')
+
         if not (self.isSIA or self.isSSA or self.isL1L2 or self.isMLHO or self.isHO or self.isFS):
             md.checkmessage("no element types set for this model")
Index: issm/trunk/src/m/classes/fourierlove.js
===================================================================
--- issm/trunk/src/m/classes/fourierlove.js	(revision 25994)
+++ issm/trunk/src/m/classes/fourierlove.js	(revision 26744)
@@ -11,14 +11,24 @@
 	this.setdefaultparameters = function() { // {{{
 		//we setup an elastic love number computation by default.
-		this.nfreq=1; 
-		this.frequencies=[0]; //Hz
-		this.sh_nmax=256; // .35 degree, 40 km at the equator.
-		this.sh_nmin=1; 
-		this.g0=10; // m/s^2; 
-		this.r0=6378*1e3; //m;
-		this.mu0=10**11; // Pa
-		this.allow_layer_deletion=1; 
-		this.love_kernels=0; 
-		this.forcing_type = 11; 
+			this.nfreq=1; 
+			this.frequencies=[0]; //Hz
+			this.sh_nmax=256; // .35 degree, 40 km at the equator.
+			this.sh_nmin=1;
+			// work on matlab script for computing g0 for given Earth's structure. 
+			this.g0=9.81; // m/s^2; 
+			this.r0=6371*1e3; //m;
+			this.mu0=1e11; // Pa
+			this.Gravitational_Constant=6.67259e-11; // m^3 kg^-1 s^-2
+			this.allow_layer_deletion=1;
+			this.underflow_tol=1e-16; //threshold of deep to surface love number ratio to trigger the deletion of layer 
+			this.integration_steps_per_layer=100;
+			this.istemporal=0;
+			this.n_temporal_iterations=8;
+			this.time=[0]; //s
+			this.love_kernels=0; 
+			this.forcing_type = 11; // surface loading
+			this.inner_core_boundary=1;
+			this.core_mantle_boundary=2;
+			this.complex_computation=0;
 	} // }}}
 	this.disp = function() { // {{{
@@ -28,26 +38,61 @@
 		fielddisplay(this,'sh_nmin','minimum spherical harmonic degree (default 1)');
 		fielddisplay(this,'g0','adimensioning constant for gravity (default 10) [m/s^2]');
-		fielddisplay(this,'r0','adimensioning constant for radius (default 6378*10^3) [m]');
+		fielddisplay(this,'r0','adimensioning constant for radius (default 6371*10^3) [m]');
 		fielddisplay(this,'mu0','adimensioning constant for stress (default 10^11) [Pa]');
+		fielddisplay(this,'Gravitational_Constant','Newtonian constant of gravitation (default 6.67259e-11 [m^3 kg^-1 s^-2])');
 		fielddisplay(this,'allow_layer_deletion','allow for migration of the integration boundary with increasing spherical harmonics degree (default 1)');
+		fielddisplay(this,'underflow_tol','threshold of deep to surface love number ratio to trigger the deletion of layers (default 2.2204460492503131E-016)');
+		fielddisplay(this,'integration_steps_per_layer','number of radial steps to propagate the yi system from the bottom to the top of each layer (default 100)');
+		fielddisplay(this,'istemporal','1 for time-dependent love numbers, 0 for frequency-dependent or elastic love numbers (default 0)', 'If 1: use fourierlove function build_frequencies_from_time to meet consistency');
+		fielddisplay(this,'n_temporal_iterations','max number of iterations in the inverse Laplace transform. Also the number of spectral samples per time step requested (default 8)');
+		fielddisplay(this,'time','time vector for deformation if istemporal (default 0) [s]');
 		fielddisplay(this,'love_kernels','compute love numbers at depth? (default 0)');
-		fielddisplay(this,'forcing_type',['integer indicating the nature and depth of the forcing for the Love number calculation (default 11) :','1:  Inner core boundary -- Volumic Potential','2:  Inner core boundary -- Pressure','3:  Inner core boundary -- Loading','4:  Inner core boundary -- Tangential traction','5:  Core mantle boundary -- Volumic Potential','6:  Core mantle boundary -- Pressure','7:  Core mantle boundary -- Loading','8:  Core mantle boundary -- Tangential traction','9:  Surface -- Volumic Potential','10: Surface -- Pressure','11: Surface -- Loading','12: Surface -- Tangential traction ']); 
+		fielddisplay(this,'forcing_type','integer indicating the nature and depth of the forcing for the Love number calculation (default 11) :','1:  Inner core boundary -- Volumic Potential','2:  Inner core boundary -- Pressure','3:  Inner core boundary -- Loading','4:  Inner core boundary -- Tangential traction','5:  Core mantle boundary -- Volumic Potential','6:  Core mantle boundary -- Pressure','7:  Core mantle boundary -- Loading','8:  Core mantle boundary -- Tangential traction','9:  Surface -- Volumic Potential','10: Surface -- Pressure','11: Surface -- Loading','12: Surface -- Tangential traction ');
+		fielddisplay(this,'inner_core_boundary','interface index in materials.radius locating forcing. Only used for forcing_type 1--4 (default 1)');
+		fielddisplay(this,'core_mantle_boundary','interface index in materials.radius locating forcing. Only used for forcing_type 5--8 (default 2)'); 
 
 	} // }}}
 	this.checkconsistency = function(md,solution,analyses) { // {{{
 
-		md = checkfield(md,'fieldname','love.nfreq','NaN',1,'Inf',1,'numel',1,'>',0);
-		md = checkfield(md,'fieldname','love.frequencies','NaN',1,'Inf',1,'numel',md.love.nfreq);
-		md = checkfield(md,'fieldname','love.sh_nmax','NaN',1,'Inf',1,'numel',1,'>',0);
-		md = checkfield(md,'fieldname','love.sh_nmin','NaN',1,'Inf',1,'numel',1,'>',0);
-		md = checkfield(md,'fieldname','love.g0','NaN',1,'Inf',1,'numel',1,'>',0);
-		md = checkfield(md,'fieldname','love.r0','NaN',1,'Inf',1,'numel',1,'>',0);
-		md = checkfield(md,'fieldname','love.mu0','NaN',1,'Inf',1,'numel',1,'>',0);
-		md = checkfield(md,'fieldname','love.allow_layer_deletion','values',[0, 1]);
-		md = checkfield(md,'fieldname','love.love_kernels','values',[0, 1]);
-		md = checkfield(md,'fieldname','love.forcing_type','NaN',1,'Inf',1,'numel',1,'>',0, '<=', 12);
-		if (md.love.sh_nmin<=1 && md.love.forcing_type==9) {
+		if (ArrayAnyEqual(ArrayIsMember('LoveAnalysis',analyses),1)) return; 
+
+		checkfield(md,'fieldname','love.nfreq','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.frequencies','NaN',1,'Inf',1,'numel',md.love.nfreq);
+		checkfield(md,'fieldname','love.sh_nmax','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.sh_nmin','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.g0','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.r0','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.mu0','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.Gravitational_Constant','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.allow_layer_deletion','values',[0, 1]);
+		checkfield(md,'fieldname','love.underflow_tol','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.integration_steps_per_layer','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','love.love_kernels','values',[0, 1]);
+		checkfield(md,'fieldname','love.forcing_type','NaN',1,'Inf',1,'numel',1,'>',0, '<=', 12);
+		checkfield(md,'fieldname','love.complex_computation','NaN',1,'Inf',1,'numel',1,'values',[0, 1]);
+
+		checkfield(md,'fieldname','love.istemporal','values',[0, 1]);
+
+		if (md.love.istemporal==1){
+			checkfield(md,'fieldname','love.n_temporal_iterations','NaN',1,'Inf',1,'numel',1,'>',0);
+			checkfield(md,'fieldname','love.time','NaN',1,'Inf',1,'numel',md.love.nfreq/2/md.love.n_temporal_iterations);
+		}
+		if (md.love.sh_nmin<=1 && md.love.forcing_type==9 || md.love.forcing_type==5 || md.love.forcing_type==1) {
 			throw 'Degree 1 not supported for Volumetric Potential forcing. Use sh_min>=2 for this kind of calculation.';
 		}
+
+		//need 'litho' material: 
+		console.log('md.fourierlove check consistency only paritally implemented for litho material');
+		/*
+		if ~isa(md.materials,'materials') | ~sum(strcmpi(md.materials.nature,'litho'))
+			error('Need a "litho" material to run a Fourier Love number analysis');
+		end
+
+		mat=find(strcmpi(md.materials.nature,'litho'));
+		if (md.love.forcing_type<=4) {
+			checkfield(md,'fieldname','love.inner_core_boundary','NaN',1,'Inf',1,'numel',1,'>',0, '<=', md.materials(mat).numlayers);
+		} else if (md.love.forcing_type<=8) {
+			checkfield(md,'fieldname','love.core_mantle_boundary','NaN',1,'Inf',1,'numel',1,'>',0, '<=', md.materials(mat).numlayers);
+		} */
 	} // }}}
 	this.marshall = function(md,prefix,fid) { // {{{
@@ -60,22 +105,39 @@
 		WriteData(fid,prefix,'object',this,'fieldname','r0','format','Double');
 		WriteData(fid,prefix,'object',this,'fieldname','mu0','format','Double');
+		WriteData(fid,prefix,'object',this,'fieldname','Gravitational_Constant','format','Double');
 		WriteData(fid,prefix,'object',this,'fieldname','allow_layer_deletion','format','Boolean');
+		WriteData(fid,prefix,'object',this,'fieldname','underflow_tol','format','Double');
+		WriteData(fid,prefix,'object',this,'fieldname','integration_steps_per_layer','format','Integer');
+		WriteData(fid,prefix,'object',this,'fieldname','istemporal','format','Boolean');
+		WriteData(fid,prefix,'object',this,'fieldname','n_temporal_iterations','format','Integer');
+		WriteData(fid,prefix,'object',this,'fieldname','complex_computation','format','Boolean');
+		//note: no need to marshall the time vector, we have frequencies
 		WriteData(fid,prefix,'object',this,'fieldname','love_kernels','format','Boolean');
 		WriteData(fid,prefix,'object',this,'fieldname','forcing_type','format','Integer');
+		WriteData(fid,prefix,'object',this,'fieldname','inner_core_boundary','format','Integer');
+		WriteData(fid,prefix,'object',this,'fieldname','core_mantle_boundary','format','Integer');
 
 	} // }}}
 	//properties 
 	// {{{
-		
-	this.nfreq                =  NaN;
-	this.frequencies          =  NaN;
-	this.sh_nmax              =  NaN;
-	this.sh_nmin              =  NaN;
-	this.g0                   =  NaN; 
-	this.r0                   =  NaN; 
-	this.mu0                  =  NaN;
-	this.allow_layer_deletion =  NaN;
-	this.love_kernels =  NaN;
-	this.forcing_type         =  NaN;
+	this.nfreq                		= NaN;
+	this.frequencies          		= NaN;
+	this.sh_nmax              		= NaN;
+	this.sh_nmin              		= NaN;
+	this.g0                   		= NaN; 
+	this.r0                   		= NaN; 
+	this.mu0                  		= NaN;
+	this.Gravitational_Constant 	= 0;
+	this.allow_layer_deletion 		= NaN;
+	this.underflow_tol              = 0;
+	this.integration_steps_per_layer= 0;
+	this.istemporal		   			= 0;
+	this.n_temporal_iterations	  	= 0;
+	this.time			            = 0;
+	this.love_kernels 				= NaN;
+	this.forcing_type         		= NaN;
+	this.inner_core_boundary	    = 0;
+	this.core_mantle_boundary	    = 0;
+	this.complex_computation        = 0;
 	
 	//set defaults
Index: issm/trunk/src/m/classes/fourierlove.m
===================================================================
--- issm/trunk/src/m/classes/fourierlove.m	(revision 25994)
+++ issm/trunk/src/m/classes/fourierlove.m	(revision 26744)
@@ -6,14 +6,24 @@
 classdef fourierlove
 	properties (SetAccess=public) 
-		nfreq                = 0;
-		frequencies          = 0;
-		sh_nmax              = 0;
-		sh_nmin              = 0;
-		g0                   = 0;
-		r0                   = 0;
-		mu0                  = 0;
-		allow_layer_deletion = 0;
-		love_kernels         = 0;
-		forcing_type         = 0;
+		nfreq                       = 0;
+		frequencies                 = 0;
+		sh_nmax                     = 0;
+		sh_nmin                     = 0;
+		g0                          = 0;
+		r0                          = 0;
+		mu0                         = 0;
+		Gravitational_Constant      = 0;
+		allow_layer_deletion        = 0;
+		underflow_tol               = 0;
+		integration_steps_per_layer = 0;
+		istemporal                  = 0;
+		n_temporal_iterations       = 0;
+		time                        = 0;
+		love_kernels                = 0;
+		forcing_type                = 0;
+		inner_core_boundary         = 0;
+		core_mantle_boundary        = 0;
+		complex_computation         = 0;
+
 	end
 	methods (Static)
@@ -24,6 +34,4 @@
 	end
 	methods
-		function self = extrude(self,md) % {{{
-		end % }}}
 		function self = fourierlove(varargin) % {{{
 			switch nargin
@@ -43,23 +51,42 @@
 			self.g0=9.81; % m/s^2; 
 			self.r0=6371*1e3; %m;
-			self.mu0=10^11; % Pa
-			self.allow_layer_deletion=1; 
+			self.mu0=1e11; % Pa
+			self.Gravitational_Constant=6.67259e-11; % m^3 kg^-1 s^-2
+			self.allow_layer_deletion=1;
+			self.underflow_tol=1e-16; %threshold of deep to surface love number ratio to trigger the deletion of layer 
+			self.integration_steps_per_layer=100;
+			self.istemporal=0;
+			self.n_temporal_iterations=8;
+			self.time=[0]; %s
 			self.love_kernels=0; 
-			self.forcing_type = 11; 
+			self.forcing_type = 11; % surface loading
+			self.inner_core_boundary=1;
+			self.core_mantle_boundary=2;
+			self.complex_computation=0;
 		end % }}}
 		function disp(self) % {{{
-			fielddisplay(self,'nfreq','number of frequencies sampled (default 1, elastic) [Hz]');
+			fielddisplay(self,'nfreq','number of frequencies sampled (default: 1, elastic) [Hz]');
 			fielddisplay(self,'frequencies','frequencies sampled (convention defaults to 0 for the elastic case) [Hz]');
-			fielddisplay(self,'sh_nmax','maximum spherical harmonic degree (default 256, .35 deg, or 40 km at equator)');
-			fielddisplay(self,'sh_nmin','minimum spherical harmonic degree (default 1)');
-			fielddisplay(self,'g0','adimensioning constant for gravity (default 10) [m/s^2]');
-			fielddisplay(self,'r0','adimensioning constant for radius (default 6378*10^3) [m]');
-			fielddisplay(self,'mu0','adimensioning constant for stress (default 10^11) [Pa]');
-			fielddisplay(self,'allow_layer_deletion','allow for migration of the integration boundary with increasing spherical harmonics degree (default 1)');
-			fielddisplay(self,'love_kernels','compute love numbers at depth? (default 0)');
-			fielddisplay(self,'forcing_type',{'integer indicating the nature and depth of the forcing for the Love number calculation (default 11) :','1:  Inner core boundary -- Volumic Potential','2:  Inner core boundary -- Pressure','3:  Inner core boundary -- Loading','4:  Inner core boundary -- Tangential traction','5:  Core mantle boundary -- Volumic Potential','6:  Core mantle boundary -- Pressure','7:  Core mantle boundary -- Loading','8:  Core mantle boundary -- Tangential traction','9:  Surface -- Volumic Potential','10: Surface -- Pressure','11: Surface -- Loading','12: Surface -- Tangential traction '}); 
+			fielddisplay(self,'sh_nmax','maximum spherical harmonic degree (default: 256, .35 deg, or 40 km at equator)');
+			fielddisplay(self,'sh_nmin','minimum spherical harmonic degree (default: 1)');
+			fielddisplay(self,'g0','adimensioning constant for gravity (default: 10) [m/s^2]');
+			fielddisplay(self,'r0','adimensioning constant for radius (default: 6371*10^3) [m]');
+			fielddisplay(self,'mu0','adimensioning constant for stress (default: 10^11) [Pa]');
+			fielddisplay(self,'Gravitational_Constant','Newtonian constant of gravitation (default: 6.67259e-11 [m^3 kg^-1 s^-2])');
+			fielddisplay(self,'allow_layer_deletion','allow for migration of the integration boundary with increasing spherical harmonics degree (default: 1)');
+			fielddisplay(self,'underflow_tol','threshold of deep to surface love number ratio to trigger the deletion of layers (default: 1e-16)');
+			fielddisplay(self,'integration_steps_per_layer','number of radial steps to propagate the yi system from the bottom to the top of each layer (default: 100)');
+			fielddisplay(self,'istemporal',{'1 for time-dependent love numbers, 0 for frequency-dependent or elastic love numbers (default: 0)', 'If 1: use fourierlove function build_frequencies_from_time to meet consistency'});
+			fielddisplay(self,'n_temporal_iterations','max number of iterations in the inverse Laplace transform. Also the number of spectral samples per time step requested (default: 8)');
+			fielddisplay(self,'time','time vector for deformation if istemporal (default: 0) [s]');
+			fielddisplay(self,'love_kernels','compute love numbers at depth? (default: 0)');
+			fielddisplay(self,'forcing_type',{'integer indicating the nature and depth of the forcing for the Love number calculation (default: 11):','1:  Inner core boundary -- Volumic Potential','2:  Inner core boundary -- Pressure','3:  Inner core boundary -- Loading','4:  Inner core boundary -- Tangential traction','5:  Core mantle boundary -- Volumic Potential','6:  Core mantle boundary -- Pressure','7:  Core mantle boundary -- Loading','8:  Core mantle boundary -- Tangential traction','9:  Surface -- Volumic Potential','10: Surface -- Pressure','11: Surface -- Loading','12: Surface -- Tangential traction '});
+			fielddisplay(self,'inner_core_boundary','interface index in materials.radius locating forcing. Only used for forcing_type 1--4 (default: 1)');
+			fielddisplay(self,'core_mantle_boundary','interface index in materials.radius locating forcing. Only used for forcing_type 5--8 (default: 2)'); 
 
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			if ~ismember('LoveAnalysis',analyses), return; end
 
 			md = checkfield(md,'fieldname','love.nfreq','NaN',1,'Inf',1,'numel',1,'>',0);
@@ -70,13 +97,36 @@
 			md = checkfield(md,'fieldname','love.r0','NaN',1,'Inf',1,'numel',1,'>',0);
 			md = checkfield(md,'fieldname','love.mu0','NaN',1,'Inf',1,'numel',1,'>',0);
+			md = checkfield(md,'fieldname','love.Gravitational_Constant','NaN',1,'Inf',1,'numel',1,'>',0);
 			md = checkfield(md,'fieldname','love.allow_layer_deletion','values',[0 1]);
+			md = checkfield(md,'fieldname','love.underflow_tol','NaN',1,'Inf',1,'numel',1,'>',0);
+			md = checkfield(md,'fieldname','love.integration_steps_per_layer','NaN',1,'Inf',1,'numel',1,'>',0);
 			md = checkfield(md,'fieldname','love.love_kernels','values',[0 1]);
 			md = checkfield(md,'fieldname','love.forcing_type','NaN',1,'Inf',1,'numel',1,'>',0, '<=', 12);
-			if md.love.sh_nmin<=1 & md.love.forcing_type==9
-				error('Degree 1 not supported for Volumetric Potential forcing. Use sh_min>=2 for this kind of calculation.')
+			md = checkfield(md,'fieldname','love.complex_computation','NaN',1,'Inf',1,'numel',1,'values',[0 1]);
+
+			md = checkfield(md,'fieldname','love.istemporal','values',[0 1]);
+			if md.love.istemporal==1
+				md = checkfield(md,'fieldname','love.n_temporal_iterations','NaN',1,'Inf',1,'numel',1,'>',0);
+				md = checkfield(md,'fieldname','love.time','NaN',1,'Inf',1,'numel',md.love.nfreq/2/md.love.n_temporal_iterations);
 			end
+			if md.love.sh_nmin<=1 & (md.love.forcing_type==1 || md.love.forcing_type==5 || md.love.forcing_type==9)
+				error(['Degree 1 not supported for forcing type ' num2str(md.love.forcing_type) '. Use sh_min>=2 for this kind of calculation.'])
+			end
+
+			%need 'litho' material: 
+			if ~isa(md.materials,'materials') | ~sum(strcmpi(md.materials.nature,'litho'))
+				error('Need a ''litho'' material to run a Fourier Love number analysis');
+			end
+
+			mat=find(strcmpi(md.materials.nature,'litho'));
+			if md.love.forcing_type<=4
+				md = checkfield(md,'fieldname','love.inner_core_boundary','NaN',1,'Inf',1,'numel',1,'>',0, '<=', md.materials(mat).numlayers);
+			elseif md.love.forcing_type<=8
+				md = checkfield(md,'fieldname','love.core_mantle_boundary','NaN',1,'Inf',1,'numel',1,'>',0, '<=', md.materials(mat).numlayers);
+			end
+
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
-		
+
 			WriteData(fid,prefix,'object',self,'fieldname','nfreq','format','Integer');
 			WriteData(fid,prefix,'object',self,'fieldname','frequencies','format','DoubleMat','mattype',3);
@@ -86,12 +136,36 @@
 			WriteData(fid,prefix,'object',self,'fieldname','r0','format','Double');
 			WriteData(fid,prefix,'object',self,'fieldname','mu0','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','Gravitational_Constant','format','Double');
 			WriteData(fid,prefix,'object',self,'fieldname','allow_layer_deletion','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','underflow_tol','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','integration_steps_per_layer','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','istemporal','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','n_temporal_iterations','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','complex_computation','format','Boolean');
+			%note: no need to marshall the time vector, we have frequencies
 			WriteData(fid,prefix,'object',self,'fieldname','love_kernels','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','forcing_type','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','inner_core_boundary','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','core_mantle_boundary','format','Integer');
 
+		end % }}}
+		function self = extrude(self,md) % {{{
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
 			error('not implemented yet!');
 		end % }}}
+		function self=build_frequencies_from_time(self) % {{{
+			if ~self.istemporal
+				error('cannot build frequencies for temporal love numbers if love.istemporal==0')
+			end
+			disp('Temporal love numbers: Overriding md.love.nfreq and md.love.frequencies');
+			self.nfreq=length(self.time)*2*self.n_temporal_iterations;
+			self.frequencies=zeros(self.nfreq,1);
+			for i=1:length(self.time)
+				for j=1:2*self.n_temporal_iterations
+					self.frequencies((i-1)*2*self.n_temporal_iterations +j) = j*log(2)/self.time(i)/2/pi;
+				end
+			end
+		end % }}}
 	end
 end
